"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const scripts_1 = __importDefault(require("@digest/scripts"));
let babelConfig = {};
if (scripts_1.default.babel) {
    babelConfig = require(scripts_1.default.babel).default();
}
const DISABLE_PLUGINS = {
    '@babel/plugin-syntax-dynamic-import': true,
    '@babel/plugin-transform-regenerator': true,
    'babel-plugin-react-css-modules': true,
    'babel-plugin-transform-inline-environment-variables': true,
    'babel-plugin-transform-node-env-inline': true
};
const DISABLE_PRESETS = {
    'babel-preset-minify': true
};
function babelPrep() {
    if (babelConfig) {
        const preparedBabelConfig = Object.assign({}, babelConfig, {
            plugins: babelConfig.plugins ?
                babelConfig.plugins.filter((plugin) => {
                    if (Array.isArray(plugin)) {
                        return !DISABLE_PLUGINS[plugin[0]];
                    }
                    return false;
                }) :
                [],
            presets: babelConfig.presets ?
                babelConfig.presets.filter((preset) => {
                    if (Array.isArray(preset)) {
                        return !DISABLE_PRESETS[preset[0]];
                    }
                    return false;
                }) :
                []
        });
        preparedBabelConfig.presets[preparedBabelConfig.presets.findIndex((preset) => {
            if (Array.isArray(preset)) {
                return preset[0] === '@babel/preset-env';
            }
            return false;
        })][1].modules = 'commonjs';
        return preparedBabelConfig;
    }
    return {};
}
exports.default = babelPrep;
